"use strict";

const conversions = require("webidl-conversions");
const utils = require("./utils.js");

const implSymbol = utils.implSymbol;
const ctorRegistrySymbol = utils.ctorRegistrySymbol;

const interfaceName = "Screen";

exports.is = value => {
    return utils.isObject(value) && utils.hasOwn(value, implSymbol) && value[implSymbol] instanceof Impl.implementation;
};
exports.isImpl = value => {
    return utils.isObject(value) && value instanceof Impl.implementation;
};
exports.convert = (value, {context = "The provided value"} = {}) => {
    if (exports.is(value)) {
        return utils.implForWrapper(value);
    }
    throw new TypeError(`${context} is not of type 'Screen'.`);
};

function makeWrapper(globalObject) {
    if (globalObject[ctorRegistrySymbol] === undefined) {
        throw new Error("Internal error: invalid global object");
    }

    const ctor = globalObject[ctorRegistrySymbol]["Screen"];
    if (ctor === undefined) {
        throw new Error("Internal error: constructor Screen is not installed on the passed global object");
    }

    return Object.create(ctor.prototype);
}

exports.create = (globalObject, constructorArgs, privateData) => {
    const wrapper = makeWrapper(globalObject);
    return exports.setup(wrapper, globalObject, constructorArgs, privateData);
};

exports.createImpl = (globalObject, constructorArgs, privateData) => {
    const wrapper = exports.create(globalObject, constructorArgs, privateData);
    return utils.implForWrapper(wrapper);
};

exports._internalSetup = (wrapper, globalObject) => {
};

exports.setup = (wrapper, globalObject, constructorArgs = [], privateData = {}) => {
    privateData.wrapper = wrapper;

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: new Impl.implementation(globalObject, constructorArgs, privateData),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper;
};

exports.new = globalObject => {
    const wrapper = makeWrapper(globalObject);

    exports._internalSetup(wrapper, globalObject);
    Object.defineProperty(wrapper, implSymbol, {
        value: Object.create(Impl.implementation.prototype),
        configurable: true
    });

    wrapper[implSymbol][utils.wrapperSymbol] = wrapper;
    if (Impl.init) {
        Impl.init(wrapper[implSymbol]);
    }
    return wrapper[implSymbol];
};

const exposed = new Set(["Window"]);

exports.install = (globalObject, globalNames) => {
    if (!globalNames.some(globalName => exposed.has(globalName))) {
        return;
    }

    class Screen {
        constructor() {
            throw new TypeError("Illegal constructor");
        }

        get availWidth() {
            console.log('availWidth', window.ENV.screenParams.availWidth)
            // return 1920;
            return window.ENV.screenParams.availWidth;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get availWidth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["availWidth"];
        }

        get availHeight() {
            console.log('availHeight', window.ENV.screenParams.availHeight)
            // return 1080;
            return window.ENV.screenParams.availHeight;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get availHeight' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["availHeight"];
        }

        get width() {
            console.log('width', window.ENV.screenParams.width)

            return window.ENV.screenParams.width;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get width' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["width"];
        }

        get height() {
            console.log('height', window.ENV.screenParams.height)

            return window.ENV.screenParams.height;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get height' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["height"];
        }

        get colorDepth() {
            return window.ENV.screenParams.colorDepth;

            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get colorDepth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["colorDepth"];
        }

        get pixelDepth() {
            return window.ENV.screenParams.pixelDepth;
            const esValue = this !== null && this !== undefined ? this : globalObject;

            if (!exports.is(esValue)) {
                throw new TypeError("'get pixelDepth' called on an object that is not a valid instance of Screen.");
            }

            return esValue[implSymbol]["pixelDepth"];
        }

        get availTop() {
            return window.ENV.screenParams.availTop
        }

        get availLeft() {
            return window.ENV.screenParams.availLeft
        }

        get innerHeight() {
            return window.ENV.screenParams.innerHeight
        }

        get outerHeight() {
            return window.ENV.screenParams.outerHeight
        }

        get outerWidth() {
            return window.ENV.screenParams.outerWidth
        }

        get innerWidth() {
            return window.ENV.screenParams.innerWidth
        }

        get screenX() {
            return window.ENV.screenParams.screenX
        }

        get pageXOffset() {
            return window.ENV.screenParams.pageXOffset
        }

        get pageYOffset() {
            return window.ENV.screenParams.pageYOffset
        }

        get devicePixelRatio() {
            return window.ENV.screenParams.devicePixelRatio
        }

        get clientWidth() {
            return window.ENV.screenParams.clientWidth
        }

        get clientHeight() {
            return window.ENV.screenParams.clientHeight
        }

        get hasHDR() {
            return window.ENV.screenParams.hasHDR
        }

    }

    var v_saf;
    !function () {
        var n = Function.toString, t = [], i = [], o = [].indexOf.bind(t), e = [].push.bind(t), r = [].push.bind(i);

        function u(n, t, tag) {
            return -1 == o(n) && (e(n), r(`function ${tag ? tag : ""}${t || n.name || ""}() { [native code] }`.replaceAll('get get', 'get'))), n
        }

        Object.defineProperty(Function.prototype, "toString", {
            enumerable: !1,
            configurable: !0,
            writable: !0,
            value: function () {
                return "function" == typeof this && i[o(this)] || n.call(this)
            }
        }), u(Function.prototype.toString, "toString"), v_saf = u
    }();
    let r = {}
    Object.keys(Object.getOwnPropertyDescriptors(Screen.prototype)).forEach(e => {
        r[e] = {}
        if (Object.getOwnPropertyDescriptor(Screen.prototype, e)['value']) {
            r[e]['value'] = v_saf(Object.getOwnPropertyDescriptor(Screen.prototype, e)['value'])
        }

        if (Object.getOwnPropertyDescriptor(Screen.prototype, e)['get']) {
            r[e]['get'] = v_saf(Object.getOwnPropertyDescriptor(Screen.prototype, e)['get'], undefined, 'get ')
        }
        r[e]['enumerable'] = true
    })
    Object.defineProperties(Screen.prototype, r)
    Object.defineProperties(Screen.prototype, {
        availWidth: {enumerable: true},
        availHeight: {enumerable: true},
        width: {enumerable: true},
        height: {enumerable: true},
        colorDepth: {enumerable: true},
        pixelDepth: {enumerable: true},
        availTop: {enumerable: true},
        availLeft: {enumerable: true},
        innerHeight: {enumerable: true},
        outerHeight: {enumerable: true},
        outerWidth: {enumerable: true},
        innerWidth: {enumerable: true},
        screenX: {enumerable: true},
        pageXOffset: {enumerable: true},
        pageYOffset: {enumerable: true},
        devicePixelRatio: {enumerable: true},
        clientWidth: {enumerable: true},
        clientHeight: {enumerable: true},
        hasHDR: {enumerable: true},
        [Symbol.toStringTag]: {value: "Screen", configurable: true}
    });
    if (globalObject[ctorRegistrySymbol] === undefined) {
        globalObject[ctorRegistrySymbol] = Object.create(null);
    }
    globalObject[ctorRegistrySymbol][interfaceName] = Screen;

    Object.defineProperty(globalObject, interfaceName, {
        configurable: true,
        writable: true,
        value: utils.proxy(Screen, 'Screen')
    });
};

const Impl = require("../window/Screen-impl.js");
